import 'package:freezed_annotation/freezed_annotation.dart';

part 'promotional_offer.freezed.dart';
part 'promotional_offer.g.dart';

@freezed

/// The signed discount applied to a payment
class PromotionalOffer with _$PromotionalOffer {
  const factory PromotionalOffer(
    /// Identifier agreed upon with the App Store for a discount of your choosing.
    String identifier,

    /// The identifier of the public/private key pair agreed upon with the
    /// App Store when the keys were generated.
    String keyIdentifier,

    /// One-time use random entropy-adding value for security.
    String nonce,

    /// The cryptographic signature generated by your private key.
    String signature,

    /// Timestamp of when the signature is created.
    int timestamp,
  ) = _PromotionalOffer;

  factory PromotionalOffer.fromJson(Map<String, dynamic> json) =>
      _$PromotionalOfferFromJson(json);
}
